//+------------------------------------------------------------------+
//|                                                       suffix.mqh |
//|                                                      nicholishen |
//|                                   www.reddit.com/u/nicholishenFX |
//+------------------------------------------------------------------+
#property copyright "nicholishen"
#property link      "www.reddit.com/u/nicholishenFX"
#property strict
#include <Strings\StringEnhanced.mqh>
#include <Arrays\ArrayString.mqh>
#include <Arrays\objvector.mqh>
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
class StrCnt : public CObject
{
public:
   string str;
   int    cnt;
   int Compare(const CObject *node,const int mode=0)const
   {
      StrCnt *other = (StrCnt*)node;
      
      if(mode==1)
      {
         if(this.str > other.str)
            return -1;
         if(this.str < other.str)
            return 1;
         return 0;
      }
      else
      {
         if(this.cnt > other.cnt)
            return -1;
         if(this.cnt < other.cnt)
            return 1;
         return 0;
      }
   }
};
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

class StringSet : public objvector<StrCnt*>
{
   public:bool Add(string element)
   {
      StrCnt *str = new StrCnt;
      str.cnt=1;str.str=element;
      bool found = false;
      for(int i=0;i<Total();i++)
      {
         if(this[i].Compare(str,1)==0)
         {
            this[i].cnt++;
            break;
         }
      }
      if(!found)
         return CArrayObj::Add(str);
      else
         delete str;
      return false;
   }
   string  Suffix()
   {
      Sort(0);
      if(Total() > 0)
      {
         if(this[0].str == "NULL")
            return "";
         else
            return this[0].str;
      }
      return "";
   }
};
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

class SuffixFilter : public CObject
{
protected:
   String            m_list;
   string            m_suffix;
public:
                     SuffixFilter():m_suffix("EMPTY"){}
   string            Suffix();//{ if(m_suffix=="EMPTY")}
   void              GetList(string &arr[]);
   void              GetList(String &arr);
   void              CorrectList(string &arr[]);
   bool              DoesExist(string);
protected:
   void              _GetList();
   
};
//+------------------------------------------------------------------+
void SuffixFilter::_GetList(void)
{
   String s= "EURUSD,GBPUSD,EURJPY,USDCAD,AUDCHF,AUDCAD,AUDNZD,";
   s+="AUDJPY,AUDUSD,CADCHF,CADJPY,CHFJPY,EURAUD,EURCAD,";
   s+="EURCHF,EURGBP,EURNZD,GBPCAD,GBPAUD,GBPCHF,GBPJPY,";
   s+="GBPNZD,NZDCAD,NZDCHF,NZDJPY,NZDUSD,USDCHF,USDJPY";
   m_list = s;
   m_list.Split(',');
   s.Split(',');
   StringSet set;
   for(int i=0;i<s.Total();i++)
   {
      for(int j=0;j<SymbolsTotal(false);j++)
      {
         if(StringFind(SymbolName(j,false),s[i].Str())>=0)
         {
            string suf = StringSubstr(SymbolName(j,false),6);
            if(StringLen(suf)>0)
               set.Add(suf);
            else
               set.Add("NULL");
         }
      }
   }
   m_suffix = set.Suffix();
   m_suffix = m_suffix=="NULL"?NULL:m_suffix;
   for(int i=0;i<m_list.Total();i++)
   {
      m_list[i].Append(m_suffix);
   }
}

void SuffixFilter::CorrectList(string &arr[])
{
   string suffix = Suffix();
   for(int i=0;i<ArraySize(arr);i++)
   {
      if(StringFind(arr[i],suffix) < 0)
         arr[i]+=suffix;
   }
   
}
//+------------------------------------------------------------------+
string  SuffixFilter::Suffix()
{  
   if(m_suffix=="EMPTY")
      _GetList();
   return m_suffix;
}
//+------------------------------------------------------------------+
void SuffixFilter::GetList(string &arr[])
{
   if(m_suffix=="EMPTY")
      _GetList();
   int total = ArrayResize(arr,m_list.Total());
   for(int i=0;i<total;i++)
   {
      string debug=m_list[i].Str();
      if(DoesExist(m_list[i].Str()))
         arr[i] = m_list[i].Str();
   }
}
//+------------------------------------------------------------------+
void SuffixFilter::GetList(String &arr)
{
   if(m_suffix=="EMPTY")
      _GetList();
   string temp="";
   for(int i=0;i<m_list.Total();i++)
   {
      temp+=m_list[i].Str();
      temp+=i==m_list.Total()-1?"":",";
   }
   arr = temp;
   arr.Split(',');
}

//+------------------------------------------------------------------+
bool SuffixFilter::DoesExist(string sym)
{
   for(int j=0;j<SymbolsTotal(false);j++)
   {
      if(StringFind(SymbolName(j,false),sym)>=0)
         return true;
   }
   return false;
}

string AssumedSuffix()
{
   static SuffixFilter filter;
   return filter.Suffix();
}